#include <bits/stdc++.h>
using namespace std;

#define endl      '\n'
#define sz(x)     int((x).size())
#define all(x)    (x).begin(), (x).end()
#define rall(x)   (x).rbegin(), (x).rend()
#define fi        first
#define se        second
#define pb        push_back
using ll = long long;
using pii = pair<int, int>;

struct SegmentTreeMin {
   int n;
   vector<long long> t;
   SegmentTreeMin(int n) : n(n), t((n << 2) + 1, INT_MAX) {}
   void update(int i, long long x, int v, int vl, int vr) {
      if (vl == vr) {
         t[v] = x;
      } else {
         int vm = (vl + vr) >> 1;
         if (i <= vm)
            update(i, x, v << 1, vl, vm);
         else
            update(i, x, v << 1 | 1, vm + 1, vr);
         t[v] = min(t[v << 1], t[v << 1 | 1]);
      }
   }
   long long query(int l, int r, int v, int vl, int vr) {
      if (l > vr || vl > r) return INT_MAX;
      else if (l <= vl && vr <= r) return t[v];
      else {
         int vm = (vl + vr) >> 1;
         long long L = query(l, r, v << 1, vl, vm);
         long long R = query(l, r, v << 1 | 1, vm + 1, vr);
         return min(L, R);
      }
   }
   void update(int i, int x) {
      update(i, x, 1, 0, n - 1);
   }
   long long query(int l, int r) {
      return query(l, r, 1, 0, n - 1);
   }
};

int main(){
	ios::sync_with_stdio(0), cin.tie(0);
	int n, m;
	cin >> n >> m;
	vector<int> l(m), r(m), len(m);
	vector<vector<long long>> dp(m, vector<long long>(n, INT_MAX));
	for (int i = 0; i < m; i++) {
		cin >> l[i] >> r[i];
		l[i]--; r[i]--;
		len[i] = r[i]-l[i]+1;
		
		dp[i][l[i]] = 0;
		for (int j = l[i]+1; j+len[i]-1 < n; j++) {
			dp[i][j] = j-l[i];
		}
		for (int j = r[i]-1; j-len[i]+1 >= 0; j--) {
			dp[i][j-len[i]+1] = r[i]-j;
		}
	}
	vector<vector<long long>> DP(m, vector<long long>(n, INT_MAX));
	SegmentTreeMin st(n);
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++) {
			if (i == 0) DP[i][j] = dp[i][j];
			else {
				DP[i][j] = min(DP[i][j], st.query(max(0,j-len[i-1]+1),min(n-1,j+len[i]-1)) + dp[i][j]);
			}
		}
		for (int j = 0; j < n; j++) {
			st.update(j, DP[i][j]);
		}
	}
	// for (int i = 0; i < m; i++) {
		// for (int j = 0; j < n; j++) {
			// cout << dp[i][j] << ' ';
		// }
		// cout << '\n';
	// }
	cout << *min_element(DP[m-1].begin(), DP[m-1].end());
	return 0;
}