#include<bits/stdc++.h>

using namespace std;

template <typename A, typename B>
string to_string(pair<A, B> p);

template <typename A, typename B, typename C>
string to_string(tuple<A, B, C> p);

template <typename A, typename B, typename C, typename D>
string to_string(tuple<A, B, C, D> p);

string to_string(const string& s) {
    return '"' + s + '"';
}

string to_string(const char& s) {
    string res = "'";
    res += s;
    res += "'";
    return res;
}

string to_string(bool b) {
    return (b ? "true" : "false");
}

string to_string(vector<bool> v) {
    string res = "{";
    for (int i = 0; i < static_cast<int>(v.size()); i++) {
        if (i) res += ", ";
        res += to_string(v[i]);
    }
    res += "}";
    return res;
}

template <size_t N>
string to_string(bitset<N> v) {
    string res = "";
    for (size_t i = 0; i < N; i++) {
        res += static_cast<char>('0' + v[i]);
    }
    return res;
}

template <typename A>
string to_string(A v) {
    bool first = true;
    string res = "{";
    for (const auto &x : v) {
        if (!first) {
            res += ", ";
        }
        first = false;
        res += to_string(x);
    }
    res += "}";
    return res;
}

template <typename A, typename B>
string to_string(pair<A, B> p) {
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

template <typename A, typename B, typename C>
string to_string(tuple<A, B, C> p) {
    return "(" + to_string(get<0>(p)) + ", " + to_string(get<1>(p)) + ", " + to_string(get<2>(p)) + ")";
}

template <typename A, typename B, typename C, typename D>
string to_string(tuple<A, B, C, D> p) {
    return "(" + to_string(get<0>(p)) + ", " + to_string(get<1>(p)) + ", " + to_string(get<2>(p)) + ", " + to_string(get<3>(p)) + ")";
}

void debug_out() { cerr << endl; }

template <typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
    cerr << " " << to_string(H);
    debug_out(T...);
}

#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#define int long long
#define fi first
#define se second
#define pii pair<int, int>
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(a) (int) (a).size()
#define eb emplace_back
#define ld long double
#define ve vector
#define forn(i, n) for (int i = 0; i < n; i++)

ve<int> merge(ve<int> a, ve<int> b) {
    int i = 0, j = 0;
    ve<int> res;
    while (i < sz(a) || j < sz(b)) {
        if (i == sz(a)) {
            res.pb(b[j]);
            j++;
            continue;
        }
        if (j == sz(b)) {
            res.pb(a[i]);
            i++;
            continue;
        }
        if (a[i] == b[j]) {
            i++, j++;
            continue;
        }
        if (a[i] < b[j]) {
            res.pb(a[i]);
            i++;
            continue;
        }
        res.pb(b[j]);
        j++;
        continue;
    }
    return res;
}

signed main() {
    //
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
    //
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    forn (i, n) cin >> a[i];
    int A = 0;
    forn (i, n) A ^= a[i];
    vector<int> b(n);
    forn (i, n) cin >> b[i];
    int B = 0;
    forn (i, n) B ^= b[i];
    int msk = 0;
    forn (i, 60) {
        if ((A >> i & 1) == (B >> i & 1)) msk += (1 << i);
    }
    vector<int> dp(n);
    forn (i, n) {
        dp[i] = a[i] ^ b[i];
        forn (j, 60) {
            if (msk >> i & 1) {

            } else {
                if (dp[i] >> i & 1) dp[i] -= (1 << i);
            }
        }
    }
    forn (i, 60) {
        if (msk >> i & 1) {
            if (A >> i & 1) msk -= (1 << i);
        }
    }
    int l = -1, r = 60;
    ve<int> res;
    int ok = 0;
    auto check = [&] (int M) {
        auto dp2 = dp;
        forn (i, n) {
            for (int j = 0; j < M; j++) {
                if (dp2[i] >> j & 1) dp2[i] -= (1 << j);
            }
        }
        const int m = 60;
        bitset<m> a[n];
        vector<int> dp[n];
        for (int i = 0; i < n; i++) {
            dp[i].pb(i);
            for (int j = 0; j < m; j++) {
                a[i][j] = (dp2[i] >> j & 1);
            }
        }
        bitset<m> b;
        for (int i = 0; i < 60; i++) {
            if (i >= M && (msk >> i & 1)) {
                b[i] = 1;
            } else {
                b[i] = 0;
            }
        }
        int tmp = 0;
        for (int v = 0; v < m && tmp < n; v++) {
            int s = tmp;
            for (int i = tmp; i < n; i++) {
                if (a[i][v] == 1) {
                    s = i;
                }
            }
            if (a[s][v] == 0) continue;
            swap(a[s], a[tmp]);
            swap(dp[s], dp[tmp]);
            for (int i = 0; i < n; i++) {
                if (i == tmp) continue;
                int x = (a[i][v] != 0);
                if (x) {
                    a[i] ^= a[tmp];
                    dp[i] = merge(dp[i], dp[tmp]);
                }
            }
            tmp++;
        }
        res.clear();
        ok = 1;
        forn (i, n) {
            int j = 59;
            while (!a[i][j]) {
                j--;
                if (j < 0) break;
            }
            if (j < 0) continue;
            if (b[j]) {
                res = merge(res, dp[i]);
                b ^= a[i];
            }
        }
        forn (i, m) if (b[i]) ok = 0;
    };
    ve<int> RES;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        int ok = 1;
        check(m);
        if (ok) {
            r = m;
            RES = res;
        } else {
            l = m;
        }
    }
    for (auto i : RES) {
        swap(a[i], b[i]);
    }
    A = 0;
    forn (i, n) A ^= a[i];
    B = 0;
    forn (i, n) B ^= b[i];
    cout << A + B << " " << sz(RES) << '\n';
    for (auto i : RES) {
        cout << i + 1 << " ";
    }
    return 0;
}
