#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <math.h>
#include <functional>
#include <string>
using namespace std;
#define all(o) (o).begin(), (o).end()
#define rall(o) (o).rbegin(), (o).rend()
using ll = long long;
#if LOCAL
#define dbg(o) {cout << #o << " = " << (o) << "\n"; o;}
#else
#define dbg(o) (o)
#endif

template<typename T>
ostream &operator<<(ostream &out, vector<T> v) {
    for (T e : v) {
        out << e << " ";
    }
    return out;
}
template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (T &e : v) {
        in >> e;
    }
    return in;
}

vector<vector<int>> graph;
vector<bool> visited;
vector<int> res;
vector<int> layer;
vector<int> next_layer;
vector<int> a;

void dfs(int v, int k) {
    res[v] = k;
    visited[v] = true;
    for (int u : graph[v]) {
        if (visited[u]) continue;
        if (k > a[u]) {
            dfs(u, k);
        } else {
            next_layer.push_back(u);
        }
    }
}

void solve() {
    int n, m; cin >> n >> m;
    graph.assign(n, vector<int>());
    a.assign(n, -1);
    for (int i = 0; i < m; ++i) {
        int v, u; cin >> v >> u;
        v--, u--;
        graph[v].push_back(u);
        graph[u].push_back(v);
    }
    int k; cin >> k;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    visited.assign(n, false);
    res.assign(n, 0);
    layer.clear();
    next_layer.clear();
    next_layer.push_back(0);

    if (k <= a[0]) k /= 2;

    while (k > 0) {
        layer = next_layer;
        next_layer.clear();
        for (int v : layer) {
            if (!visited[v]) {
                dfs(v, k);
            }
        }
        k /= 2;
    }

    cout << res[n - 1] << "\n";
}


int main() {
    cout.precision(16);
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#if LOCAL
    freopen("../A.in", "r", stdin);
    // freopen("../A.out", "w", stdout);
#endif
    solve();
    return 0;
}
