#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;
#define all(x) (x).begin(), (x).end()

const int inf = 1e9;

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL); cout.tie(NULL);

	int n, m; cin >> n >> m;
	vector<pair<int, int>> a(m);
	for (auto& c : a) {
		cin >> c.first >> c.second;
		c.first--;
		c.second--;
	}
	
	vector<map<int, int>> dp(m);
	int l = a[0].first, r = a[0].second;
	for (int cur_x = -l; cur_x <= n - 1 - r; cur_x++) {
		dp[0][cur_x] = abs(cur_x);
	}

	for (int j = 1; j < m; j++) {
		l = a[j].first, r = a[j].second;
		for (int cur_x = -l; cur_x <= n - 1 - r; cur_x++) {
			dp[j][cur_x] = inf;
			for (auto pred : dp[j - 1]) {
				int cur_l = l + cur_x, cur_r = r + cur_x, pred_l = a[j - 1].first + pred.first, pred_r = a[j - 1].second + pred.first;
				if (max(cur_l, pred_l) <= min(cur_r, pred_r)) {
					dp[j][cur_x] = min(dp[j][cur_x], pred.second + abs(cur_x));
				}
			}
		}
	}

	int ans = inf;
	for (auto c : dp[m - 1]) {
		ans = min(ans, c.second);
	}
	cout << ans;

	return 0;
}