#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()

const int inf = 1e9;

ll make_k(ll a, ll b) {
	// a > b
	if (abs(a) % abs(b) == 0) {
		ll k = abs(a / b);
		if ((a < 0 && b < 0) || (a > 0 && b > 0))
			return -k;
		else
			return k;
	}

	ll k1 = abs(a / b), k2 = k1 + 1;
	if ((a < 0 && b < 0) || (a > 0 && b > 0)) {
		k1 = 0 - k1;
		k2 = 0 - k2;
	}
	if (abs(a + k1 * b) < abs(a + k2 * b))
		return k1;
	else
		return k2;
}

int main() {

	ll a, b;
	cin >> a >> b;
	vector<pair<int, ll>> ans;
	while (true) {
		if (a == 0 || b == 0)
			break;
		if (abs(a) == abs(b)) {
			if (a == b)
				ans.emplace_back(1, -1);
			if (a == -b)
				ans.emplace_back(1, 1);
			break;
		}
		if (abs(a) > abs(b)) {
			ll k = make_k(a, b);
			ans.emplace_back(1, k);
			a = a + b * k;
		}
		else {
			ll k = make_k(b, a);
			ans.emplace_back(2, k);
			b = b + a * k;
		}
	}
	cout << ans.size() << '\n';
	for (auto i : ans)
		cout << i.first << ' ' << i.second << '\n';
	return 0;
}