#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <deque>
#include <queue>
#include <algorithm>
#include <map>
#include <string>
using ll = long long;
using namespace std;

ll gcd(ll a, ll b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

double binpow(double a, int n) { // a ^ n % m
    if (n == 0) return 1;
    if (n % 2 == 0) {
        double x = binpow(a, n / 2);
        return x * x;
    }
    else return a * binpow(a, n - 1);
}

ll phi(ll n) {
    ll res = n;
    for (ll p = 2; p * p <= n; ++p) {
        if (n % p == 0)
            res -= res / p;
        while (n % p == 0)
            n /= p;
    }
    if (n > 1)
        res -= res / n;
    return res;
}

vector<int> factorization(int n) {
    vector<int> p;
    for (ll d = 2; d * 1ll * d <= n; ++d) {
        if (n % d == 0) p.push_back(d);
        while (n % d == 0) {
            n /= d;
        }
    }
    if (n > 1) {
        p.push_back(n);
    }
    return p;
}

struct Tree {
  int n;
  vector<int> t;

  void build(vector<int>& A) {
    n = 1; //     
    while (n < A.size()) n *= 2;
    t.resize(n * 2);
    for (int i = n; i < (n + A.size()); ++i) {
      t[i] = A[i - n];
    }
    for (int i = (n - 1); i <= 1; --i) {
      t[i] = t[i * 2] + t[i * 2 + 1];
    }
  }

  void set(int ind, int value) {
    ind += n;
    t[ind] = value;
    ind /= 2;
    while (ind >= 1) {
      t[ind] = t[ind * 2] + t[ind * 2 + 1];
      ind /= 2;
    }
  }

  int getsum(int l, int r) {
    l += n;
    r += n;
    int sum = 0;
    for (; l <= r; l /= 2, r /= 2) {
      if (l % 2 == 1) {
        sum += t[l];
        l++;
      }
      if (r % 2 == 0) {
        sum += t[r];
        r--;
     }
    }

    return sum;
  }
};



int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);


    int n, m, k; cin >> n >> m >> k;
    if (n >= k && m >= k) {
        cout << "Possible\n";
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (i == j && k) {
                    cout << "*";
                    --k;
                }
                else cout << ".";
            }
            cout << endl;
        }
        return 0;
    }
    cout << "Impossible";
}
