﻿#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <deque>
#include <queue>
#include <algorithm>
#include <map>
#include <string>
#include <iomanip>
#define int long long
using namespace std;

int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

double binpow(double a, int n) { // a ^ n % m
    if (n == 0) return 1;
    if (n % 2 == 0) {
        double x = binpow(a, n / 2);
        return x * x;
    }
    else return a * binpow(a, n - 1);
}

int phi(int n) {
    int res = n;
    for (int p = 2; p * p <= n; ++p) {
        if (n % p == 0)
            res -= res / p;
        while (n % p == 0)
            n /= p;
    }
    if (n > 1)
        res -= res / n;
    return res;
}

vector<int> factorization(int n) {
    vector<int> p;
    for (int d = 2; d * 1ll * d <= n; ++d) {
        if (n % d == 0) p.push_back(d);
        while (n % d == 0) {
            n /= d;
        }
    }
    if (n > 1) {
        p.push_back(n);
    }
    return p;
}

struct Tree {
    int n;
    vector<int> t;

    void build(vector<int>& A) {
        n = 1; // размер массива в дереве отрезков
        while (n < A.size()) n *= 2;
        t.resize(n * 2);
        for (int i = n; i < (n + A.size()); ++i) {
            t[i] = A[i - n];
        }
        for (int i = (n - 1); i <= 1; --i) {
            t[i] = t[i * 2] + t[i * 2 + 1];
        }
    }

    void set(int ind, int value) {
        ind += n;
        t[ind] = value;
        ind /= 2;
        while (ind >= 1) {
            t[ind] = t[ind * 2] + t[ind * 2 + 1];
            ind /= 2;
        }
    }

    int getsum(int l, int r) {
        l += n;
        r += n;
        int sum = 0;
        for (; l <= r; l /= 2, r /= 2) {
            if (l % 2 == 1) {
                sum += t[l];
                l++;
            }
            if (r % 2 == 0) {
                sum += t[r];
                r--;
            }
        }

        return sum;
    }
};

bool cmp(pair<int, pair<int, char>> a, pair<int, pair<int, char>> b) {
    return a.first < b.first;
}

bool cmp1(pair<int, pair<int, char>> a, pair<int, pair<int, char>> b) {
    return a.second.first < b.second.first;
}

const long double eps = 1e-12;
long double X, T;

long double f(long double Y) {
    if (Y < 6) {
        return (X + (((100 - X) / (T / 3 - T / 6)) * (T / Y - T / 6)));
    }
    else {
        return (6.0 * X / Y);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n; cin >> n;
    vector<vector<int>> b(n, vector<int>(0));
    for (int i = 0; i < n; ++i) {
        b[i].resize(i + 2);
    }
    vector<int> pr(n + 1);
    cout << "? 1 1" << endl;
    int s; cin >> s;
    int lb, rb; cin >> lb >> rb;
    --lb; --rb;
    b[lb][rb] = 1;
    pr[1] = s;
    for (int i = 1; i < n; ++i) {
        //for (int j = i; b[i][j] != 1; --j) {
        //
        //}
        int j = i;
        while (b[max(i, j)][min(i, j)] == 1) {
            --j;
        }
        cout << "? " << j + 1 << " " << i + 1 << endl;
        cin >> s;
        cin >> lb >> rb;
        --lb; --rb;
        b[lb][rb] = 1;
        int tmp = pr[j] - pr[i] + s;
        //a[i] = pr[j] - pr[i] + s;
        pr[i + 1] = pr[i] + tmp;    
    }
    cout << "!" << endl;
    for (int i = 1; i < n + 1; ++i) {
        cout << pr[i] - pr[i - 1] << " ";
    }
}