#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <deque>
#include <queue>
#include <algorithm>
#include <map>
#include <string>
#define int long long
using namespace std;

int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

double binpow(double a, int n) { // a ^ n % m
    if (n == 0) return 1;
    if (n % 2 == 0) {
        double x = binpow(a, n / 2);
        return x * x;
    }
    else return a * binpow(a, n - 1);
}

int phi(int n) {
    int res = n;
    for (int p = 2; p * p <= n; ++p) {
        if (n % p == 0)
            res -= res / p;
        while (n % p == 0)
            n /= p;
    }
    if (n > 1)
        res -= res / n;
    return res;
}

vector<int> factorization(int n) {
    vector<int> p;
    for (int d = 2; d * 1ll * d <= n; ++d) {
        if (n % d == 0) p.push_back(d);
        while (n % d == 0) {
            n /= d;
        }
    }
    if (n > 1) {
        p.push_back(n);
    }
    return p;
}

struct Tree {
  int n;
  vector<int> t;

  void build(vector<int>& A) {
    n = 1; //     
    while (n < A.size()) n *= 2;
    t.resize(n * 2);
    for (int i = n; i < (n + A.size()); ++i) {
      t[i] = A[i - n];
    }
    for (int i = (n - 1); i <= 1; --i) {
      t[i] = t[i * 2] + t[i * 2 + 1];
    }
  }

  void set(int ind, int value) {
    ind += n;
    t[ind] = value;
    ind /= 2;
    while (ind >= 1) {
      t[ind] = t[ind * 2] + t[ind * 2 + 1];
      ind /= 2;
    }
  }

  int getsum(int l, int r) {
    l += n;
    r += n;
    int sum = 0;
    for (; l <= r; l /= 2, r /= 2) {
      if (l % 2 == 1) {
        sum += t[l];
        l++;
      }
      if (r % 2 == 0) {
        sum += t[r];
        r--;
     }
    }

    return sum;
  }
};



signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);


    int a, b; cin >> a >> b;
    int sqrta = sqrt(a), sqrtb = sqrt(b);
    int cnt = 0;
    for (int i = sqrta; i <= sqrtb; ++i) {
        int cur = i * i;
        int nwcur;
        string curstr = to_string(cur);
        reverse(curstr.begin(), curstr.end());
        if (curstr[0] == '0') continue;
        nwcur = stoi(curstr);
        int sqrtn = sqrt(nwcur);
        if (sqrtn * sqrtn == nwcur) {
            ++cnt;
        }
    }
    cout << cnt;
}
