#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

#include <iomanip>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<vector<pair<ll, char>>> graph_t;

const ll INF = 1e18;

ld ef(ld p, ld x, ld t) {
    if (p <= t / 6) {
        return ((6 * x) / t * p) * (t - p);
    } else if (p <= t / 3) {
        return (((600 - 6 * x) / t) * p + (2 * x - 100)) * (t - p);
    } else {
        return 100 * (t - p);
    }
}

const ld EPS = 1e-6;

void solve() {
    ld x, t;
    cin >> x >> t;
    ld l = 0;
    ld r = t;
    for (ll i = 0; i < 2000; i++) {
        ld ml = l + 1 * (r - l) / 3;
        ld mr = l + 2 * (r - l) / 3;
        if (ef(ml, x, t) < ef(mr, x, t)) {
            l = ml;
        } else {
            r = mr;
        }
    }
    cout << setprecision(10) << fixed << ef(l, x, t);
}


int main() {
    solve();
    return 0;
}
