#define _USE_MATH_DEFINES

#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <cmath>
#include <set>
#include <stack>
#include <bitset>
#include <map>
#include <ctime>
#include <numeric>
#include <random>

#define int long long
#define uint unsigned long long
#define double long double

#ifdef DIDEDOSHKA
#define start cout.setf(ios::fixed); cout.precision(10); int START = clock()
#define finish cout << "\ntime: " << (clock() - START) / (double)(CLOCKS_PER_SEC); return 0
#else
#define start cin.tie(NULL); cout.tie(NULL); cout.setf(ios::fixed); cout.precision(10); ios_base::sync_with_stdio(false)
#define finish return 0
#endif

using namespace std;


//vector input
template<typename T>
istream &operator>>(istream &is, vector<T> &vec) {
	for (auto &i : vec) {
		is >> i;
	}
	return is;
}

//vector output
template<typename T>
ostream &operator<<(ostream &os, vector<T> &vec) {
	for (T i : vec) {
		os << i << ' ';
	}
	return os;
}

//2 dimensional vector output
template<typename T>
ostream &operator<<(ostream &os, vector<vector<T>> &vec) {
	for (vector<T> i : vec) {
		os << i << '\n';
	}
	return os;
}

struct segtree {
	
	vector<int> tree;
	int size;
	
	segtree(int n) {
		size = 1;
		while (size < n) {
			size *= 2;
		}
		tree.resize(2 * size - 1, INT64_MAX);
	}
	
	void set(int i, int v, int x, int lx, int rx) {
		if (rx - lx == 1) {
			tree[x] = v;
			return;
		}
		int m = (lx + rx) / 2;
		if (i < m) {
			set(i, v, 2 * x + 1, lx, m);
		} else {
			set(i, v, 2 * x + 2, m, rx);
		}
		tree[x] = min(tree[2 * x + 1], tree[2 * x + 2]);
	}
	
	void set(int i, int v) {
		set(i, v, 0, 0, size);
	}
	
	int sum(int l, int r, int x, int lx, int rx) {
		if (lx >= r || rx <= l) {
			return INT64_MAX;
		}
		if (lx >= l && rx <= r) {
			return tree[x];
		}
		int s1 = sum(l, r, 2 * x + 1, lx, (lx + rx) / 2);
		int s2 = sum(l, r, 2 * x + 2, (lx + rx) / 2, rx);
		return min(s1, s2);
	}
	
	int sum(int l, int r) {
		return sum(l, r, 0, 0, size);
	}
};

void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> a(n), b(n), d(n);
	for (int i = 0; i < m; i++) {
		cin >> a[i] >> b[i];
		a[i]--;
		b[i]--;
		d[i] = b[i] - a[i];
	}
	vector<vector<int>> dp(m, vector<int>(n, INT64_MAX));
	dp[0][b[0]] = 0;
	for (int i = b[0] + 1; i < n; i++)
		dp[0][i] = dp[0][i - 1] + 1;
	for (int i = b[0] - 1; i >= d[i]; i--)
		dp[0][i] = dp[0][i + 1] + 1;
	segtree last(n);
	for (int i = 0; i < n; i++)
		last.set(i, dp[0][i]);
	for (int i = 1; i < m; i++) {
		segtree tmp(n);
		for (int j = d[i]; j < n; j++) {
			int l = j - d[i], r = min(n, j + d[i - 1] + 1);
			int cur = last.sum(l, r) + abs(b[i] - j);
			tmp.set(j, cur);
		}
		swap(last, tmp);
	}
	int ans = last.sum(0, n);
	cout << ans << '\n';
}

int32_t main() {
	start;
	
	solve();
	
	finish;
}