#include <bits/stdc++.h>

#define pudge ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define all(a) a.begin(), a.begin()
#define eb emplace_back
#define bp push_back

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair<ll, ll> pll;


const double PI = acos(-1);
const ll INF = 1e9 + 9;
const int MOD = 1e9 + 7;
const ld E = 1e-6;
const ll N = 300000;
const double eps = 1e-9;

template<typename T>
struct Vector {
    T x, y;

    constexpr Vector() = default;

    constexpr Vector(T x, T y) : x(x), y(y) {}

    constexpr Vector(Vector<T> const &a, Vector<T> const &b) : x(b.x - a.x), y(b.y - a.y) {}

    constexpr T squared_magnitude() { return x * x + y * y; }

    constexpr T length() { return sqrt(squared_magnitude()); }

    constexpr Vector<T> operator+(Vector<T> const &other) { return Vector(x + other.x, y + other.y); }

    constexpr Vector<T> operator-(Vector<T> const &other) { return Vector(x - other.x, y - other.y); }

    constexpr Vector<T> operator+(T scalar) { return Vector(x + scalar, y + scalar); }

    constexpr Vector<T> operator-() { return Vector(-x, -y); }

    constexpr Vector<T> operator*(T scalar) { return Vector(x * scalar, y * scalar); }

    constexpr bool operator==(Vector<T> const &other) { return x == other.x && y == other.y; }

    friend istream &operator>>(istream &is, Vector &v) { return is >> v.x >> v.y; }

    friend ostream &operator<<(ostream &os, Vector const &v) { return os << v.x << ' ' << v.y; }
};

template<typename T>
constexpr T dot(Vector<T> const &a, Vector<T> const &b) { return a.x * b.x + a.y * b.y; }

template<typename T>
constexpr T cross(Vector<T> const &a, Vector<T> const &b) { return a.x * b.y - a.y * b.x; }

template<typename T>
constexpr T angle(Vector<T> const &a, Vector<T> const &b) { return atan2(cross(a, b), dot(a, b)); }

template<typename T>
constexpr Vector<T> rotate(Vector<T> const &a, Vector<T> const &b, double alpha) {
    auto dv = Vector(a, b);
    T cos_alpha = cos(alpha);
    T sin_alpha = sin(alpha);
    auto dv1 = Vector(dv.x * cos_alpha - dv.y * sin_alpha, dv.x * sin_alpha + dv.y * cos_alpha);
    return a + dv1;
}

class Tree {
public:
    Tree(ll _n) {
        n = 1;
        while (n < _n) {
            n *= 2;
        }
        t.assign(2 * n, 0);
    }

    void build(const vector<ll> &a) {
        for (ll i = 0; i < a.size(); ++i) {
            t[n + i] = a[i];
        }
        for (ll i = n - 1; i > 0; --i) {
            t[i] = t[2 * i] ^ t[2 * i + 1];
        }
    }

    void update(ll i, ll v) {
        i += n;
        t[i] = v;
        for (i /= 2; i > 0; i /= 2) {
            t[i] = t[2 * i] ^ t[2 * i + 1];
        }
    }

    ll get(ll l, ll r) {
        return _get(1, 0, n, l, r);
    }

private:
    vector<ll> t;
    ll n;

    ll _get(ll p, ll a, ll b, ll l, ll r) {
        if (a >= r || b <= l) {
            return 0;
        }
        if (a >= l && b <= r) {
            return t[p];
        }
        ll m = (a + b) / 2;
        return _get(2 * p, a, m, l, r) ^ _get(2 * p + 1, m, b, l, r);
    }
};

bool is_glas(char c) {
    return c == 'a' || c == 'e' || c == 'i' || c == 'o' || c == 'u';
}

unordered_map<ll, bool> bad;

bool check(ll a, ll b) {
    return !bad[(a | (b << 32))];
}

void color(ll a, ll b) {
    bad[(a | (b << 32))] = true;
}

ll ask(ll a, ll b) {
    b--;
    cout << "? " << a + 1 << ' ' << b + 1 << endl;
    ll s, wa, wb;
    cin >> s >> wa >> wb;
    color(wa - 1, wb);
    return s;
}

void answer(vector<ll> &ans) {
    cout << '!' << endl;
    for (auto &it : ans) cout << it << ' ';
    cout << endl;
}

int main() {
    pudge;

    ll n;
    cin >> n;
    vector<ll> a(n);
    vector<ll> b(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) cin >> b[i];
    Tree tree1(n);
    Tree tree2(n);
    tree1.build(a);
    tree2.build(b);
    vector<ll> c;
    ll ans = tree1.get(0, n) + tree2.get(0, n);
    for (int i = 0; i < n; ++i) {
        tree1.update(i, b[i]);
        tree2.update(i, a[i]);
        if (ans <= tree1.get(0, n) + tree2.get(0, n)) {
            ans = tree1.get(0, n) + tree2.get(0, n);
            c.push_back(i);
        } else {
            tree1.update(i, a[i]);
            tree2.update(i, b[i]);
        }
    }
    cout << ans << " " << c.size() << "\n";
    for (auto elem : c) cout << elem + 1 << " ";
    cout << "\n";
    return 0;
}