#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

ll mask = 0;
struct Node {
    Node* l = nullptr;
    Node* r = nullptr;
    int ind = -1;
    Node() = default;
};

void add(Node* v, int ind, int i = 0) {
    if (i == 60) {
        if(v->ind == -1)
            v->ind = ind;
        return;
    }
    bool t = (((1ll << (59 - i)) & mask) != 0);
    if (t) {
        if (v->r == nullptr)
            v->r = new Node();
        add(v->r, ind, i + 1);
    }
    else {
        if (v->l == nullptr)
            v->l = new Node();
        add(v->l, ind, i + 1);
    }
}
int get(Node* v, int i = 0) {
    if (v->l == nullptr && v->r == nullptr)
        return v->ind;
    bool t = (((1ll << (59 - i)) & mask) != 0);
    if ((t && v->l != nullptr) || v->r == nullptr) {
        return get(v->l, i + 1);
    }
    else {
        mask ^= (1ll << (59 - i));
        return get(v->r, i + 1);
    }
}

ll gcd(ll a, ll b) {
    while (a && b) {
        if (a > b) a %= b;
        else b %= a;
    }
    return a + b;
}
void solve() {
    int n; cin >> n;
    vector<ll>x(n);
    ll A = 0, B = 0;
    for (auto& i : x) {
        cin >> i;
        A ^= i;
    }
    for (int i = 0; i < n; i++) {
        ll b; cin >> b;
        B ^= b;
        x[i] ^= b;
    }
    ll out = 0, mask_down = 0;
    for (int i = 0; i < 60; i++) {
        if ((A & (1ll << i)) != (B & (1ll << i))) {
            out += (1ll << i);
            mask_down |= (1ll << i);
        }
    }
    mask_down = ~mask_down;
    A &= mask_down;
    B &= mask_down;
    for (int i = 0; i < n; i++) {
        x[i] &= mask_down;
    }
    vector<int>pr(n + 1, -1);
    mask = A;
    Node* root = new Node();
    add(root, 0);
    for (int i = 1; i <= n; i++) {
        mask = x[i - 1];
        pr[i] = get(root);
        add(root, i);
    }
    mask = 0;
    int start = get(root);
    cout << 2 * mask + out << ' ';
    vector<int>inds;
    while (start != 0) {
        inds.push_back(start);
        start = pr[start];
    }
    reverse(inds.begin(), inds.end());
    cout << inds.size() << '\n';
    for (auto i : inds)
        cout << i << ' ';
}

void solve1() {
    int n; cin >> n;
    vector <pair <ll, ll>> a(n + 1);
    ll ans = 0;
    for (int i = 1; i <= n; i++) cin >> a[i].first >> a[i].second;
    for (int l = 1; l <= n; l++) {
        for (int k = l + 1; k <= n; k++) {
            map <pair <ll, ll>, ll> kolt;
            for (int i = k + 1; i <= n; i++) {
                ll a1 = a[l].first * i - a[l].first * k - a[i].first * l + a[k].first * l + a[i].first * k - a[k].first * i;
                ll b1 = a[k].second * i - a[l].second * i + a[l].second * k - a[i].second * k + a[i].second * l - a[k].second * l;
                if (a1 != 0 && b1 != 0) {
                    ll c = gcd(abs(a1), abs(b1));
                    a1 /= c;
                    b1 /= c;
                }
                if (a1 * b1 < 0) continue;
                kolt[{a1, b1}]++;
            }
            for (auto i : kolt) ans = max(ans, i.second);
        }
    }
    cout << ans + 2;
}
int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
    while (t--) {
        solve1();
    }
}