#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

ld x; 
ld t, t3, t6, eps = 1e-20;

ld get3(ld sleep) {
    ld dop = 100 * sleep / t3;
    return (t - sleep) * dop;
}
ld get6(ld sleep) {
    ld dop = x * sleep / t6;
    return (t - sleep) * dop;
}

void solve() {
    cin >> x >> t;
    t3 = t / 3;
    t6 = t / 6;
    ld l = 0, r = t6, ans = -1;
    for (int i = 0; i < 100000; i++) {
        ld m1 = l + (r - l) / 3.0, m2 = r - (r - l) / 3.0;
        ld ans1 = get6(m1), ans2 = get6(m2);
        if (ans1 - ans2 <= eps)
            l = m1;
        else
            r = m2;
    }
    ans = max(ans, max(get6(l), get6(r)));
    l = t6, r = t3;
    for (int i = 0; i < 100000; i++) {
        ld m1 = l + (r - l) / 3.0, m2 = r - (r - l) / 3.0;
        ld ans1 = get3(m1), ans2 = get3(m2);
        if (ans1 - ans2 <= eps)
            l = m1;
        else
            r = m2;
    }
    ans = max(ans, max(get3(l), get3(r)));
    cout << setprecision(10) << fixed << ans;
}

void print_ans(vector<char>& ans, vector<pair<int, int>>&arr) {
    int s = 0;
    for (int i = 0; i < ans.size(); i++)
        if (ans[i] == 'P')
            s += arr[i].second;
        else
            s += arr[i].first;
    cout << s << '\n';
    for (auto i : ans)
        cout << i << ' ';
}
void solve1() {
    int n, a, b;
    cin >> n >> a >> b;
    vector<pair<int, int>>arr(n);
    for (auto& i : arr)
        cin >> i.first;
    for (auto& i : arr)
        cin >> i.second;
    vector<char>ans(n);
    for (int i = 0; i < n; i++) {
        if (arr[i].first > arr[i].second) {
            ans[i] = 'T';
            a--;
        }
        else {
            ans[i] = 'P';
            b--;
        }
    }
    if (a <= 0 && b <= 0) {
        print_ans(ans, arr);
        return;
    }
    set<pair<int, int>>s;
    for (int i = 0; i < n; i++) {
        if (ans[i] == 'P' && a > 0)
            s.insert({ arr[i].second - arr[i].first, i });
        else
            if (ans[i] == 'T' && b > 0)
                s.insert({ arr[i].first - arr[i].second, i });
    }
    while (a > 0 || b > 0) {
        int i = s.begin()->second;
        ans[i] = ans[i] == 'P' ? 'T' : 'P';
        s.erase(s.begin());
        if (a > 0)
            a--;
        else
            b--;
    }
    print_ans(ans, arr);
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
    while (t--) {
        solve1();
    }
}