#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <set>
#include <map>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <cassert>
#include <cstring>
#include <random>
#include <chrono>
#include <ext/rope>
#include <bitset>

#define sqr(x) ((x) * (x))
#define fi first
#define se second
#define pb push_back
#define all(x) x.begin(),x.end()
#define sz(x) ((ll)(x).size())

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;
using ll = long long;
using ld = long double;

template <class T>
using indexed_set = tree <T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update>;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
ld Time() { return ld(clock()) / CLOCKS_PER_SEC; }

int n, m;
const int aboba = 1e8;

const vector <int> dr = {-1, 0, 1};
const vector <int> dc = {0, 1, 0};

bool ok(int r, int c) {
    return min(r, c) >= 0 && r < n && c < m;
}

struct kek {
    int r, c, val;
    kek(){};
    explicit kek(int x, int y, int z) {
        r = x, c = y, val = z;
    }

    bool operator < (kek a) const {
        if (val != a.val) {
            return val > a.val;
        }

        if (r != a.r) {
            return r > a.r;
        }

        return c > a.c;
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    cin >> n >> m;

    vector <pair <int, int>> a(m);
    for (auto &i : a) {
        cin >> i.first >> i.second;
        --i.first, --i.second;
    }

    priority_queue <kek> q;
    vector <vector <int>> dist(n, vector <int> (m, aboba));

    for (int i = a[0].first; i <= a[0].second; ++i) {
        dist[i][0] = 0;
        q.push(kek(i, 0, 0));
    }

    while (!q.empty()) {
        kek cur = q.top();
        q.pop();

        if (cur.val > dist[cur.r][cur.c]) {
            continue;
        }

        for (int k = 0; k < 3; ++k) {
            int r = cur.r + dr[k], c = cur.c + dc[k];
            if (!ok(r, c)) {
                continue;
            }

            if (a[c].first <= r && r <= a[c].second && dist[r][c] > dist[cur.r][cur.c]) {
                dist[r][c] = dist[cur.r][cur.c];
                q.push(kek(r, c, dist[r][c]));
                continue;
            }

            if (c == cur.c && dist[r][c] > dist[cur.r][cur.c] + 1) {
                dist[r][c] = dist[cur.r][cur.c] + 1;
                q.push(kek(r, c, dist[r][c]));
                continue;
            }

            if (dist[r][c] > dist[cur.r][cur.c] + min(abs(r - a[c].first), abs(r - a[c].second))) {
                dist[r][c] = dist[cur.r][cur.c] + min(abs(r - a[c].first), abs(r - a[c].second));
                q.push(kek(r, c, dist[r][c]));
                continue;
            }
        }
    }

    cout << dist[a.back().first][m - 1];

    return 0;
}