#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <utility>
#include <sstream>
#include <numeric>
#include <algorithm>
#include <cmath>
#include <vector>
#include <queue>
#include <deque>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <random>
#include <chrono>
#include <fstream>
#include <bitset>
#include <complex>
#include <cassert>
#include <memory>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int INF = 1e9;

vector<int> st1, st2, min1, min2;

void add(int val) {
    st1.emplace_back(val);
    min1.emplace_back(min(val, (min1.empty() ? INF : min1.back())));
}

void del() {
    if (st2.empty()) {
        while (!st1.empty()) {
            st2.emplace_back(st1.back());
            min2.emplace_back(min(st1.back(), (min2.empty() ? INF : min2.back())));
            st1.pop_back();
            min1.pop_back();
        }
    }
    st2.pop_back();
    min2.pop_back();
}

int getmin() {
    int val1 = INF, val2 = INF;
    if (!min1.empty()) {
        val1 = min1.back();
    }
    if (!min2.empty()) {
        val2 = min2.back();
    }
    return min(val1, val2);
}

void solve() {

    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> lines(m);
    for (int i = 0; i < m; ++i) {
        cin >> lines[i].first >> lines[i].second;
        --lines[i].first;
        --lines[i].second;
        lines[i].second -= lines[i].first;
    }
    vector<vector<int>> dp(m, vector<int>(n, INF));
    for (int i = 0; i + lines[0].second < n; ++i) {
        dp[0][i] = abs(i - lines[0].first);
    }
    for (int i = 1; i < m; ++i) {
        int lnow = 0, rnow = 0;
        add(dp[i - 1][0]);
        for (int j = 0; j + lines[i].second < n; ++j) {
            dp[i][j] = abs(j - lines[i].first);
            int l = max(j - lines[i - 1].second, 0);
            int r = min(j + lines[i].second, n - 1);
            while (rnow < r) {
                add(dp[i - 1][++rnow]);
            }
            while (lnow < l) {
                del();
                ++lnow;
            }
            dp[i][j] += getmin();
        }
        st1.clear();
        st2.clear();
        min1.clear();
        min2.clear();
    }
    cout << *min_element(dp[m - 1].begin(), dp[m - 1].end()) << "\n";

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    t = 1;
    while (t--) {
        solve();
    }

    return 0;
}