#include <iostream>
#include <vector>
#include <queue>
#include <set>

using namespace std;


int main() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> graph(n);

    for (int i = 0; i < m; i++) {
        int tmp1, tmp2;
        cin >> tmp1 >> tmp2;
        tmp1--;
        tmp2--;
        graph[tmp1].push_back(tmp2);
        graph[tmp2].push_back(tmp1);
    }

    vector<int> droids(n);

    int num;
    cin >> num;
    for (int i = 0; i < n; i++) {
        cin >> droids[i];
    }

    const int INF = 100000000;

    set<pair<int, int>> q;
    vector<int> dist(n, -INF);
    if (droids[0] >= num)
        num /= 2;
    q.insert(make_pair(0, num));
    dist[0] = num;

    while (!q.empty()) {
        auto cur = *q.begin();
        q.erase(q.begin());

        int u = cur.first;
        int nn = cur.second;

        for (auto p : graph[u]) {
            int newNum;
            if (droids[p] >= nn) {
                newNum = nn / 2;
            } else {
                newNum = nn;
            }
            if (dist[p] < newNum) {
                q.erase(make_pair(p, newNum));
                dist[p] = newNum;
                q.insert(make_pair(p, newNum));
            }
        }
    }

    cout << dist[n-1] << endl;

    return 0;
}