#include <algorithm>
#include <cassert>
#include <cmath>
#include <iomanip>
#include <ios>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <string>
#include <unordered_map>
#include <utility>
#include <vector>
using namespace std;

#define int long long

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)(x).size()
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define pb push_back
using ll = long long;
using db = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vi = vector<int>;
using vll = vector<ll>;

void fastio() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
    cin.exceptions(ios::failbit);
}

inline void solve() noexcept {
    int n, m;
    cin >> n >> m;

    vector<vi> g(n);
    forn(i, m) {
        int v, u;
        cin >> v >> u;
        --v, --u;

        g[v].pb(u); g[u].pb(v);
    }

    vector<int> a(n);
    int cnt;
    cin >> cnt;

    forn(i, n) cin >> a[i];

    if (a[0] > cnt) cnt /= 2;

    vector<int> dist(n);
    set<pair<int, int>> q;

    dist[0] = -cnt;
    q.insert({-cnt, 0});

    while (!q.empty()) {
        auto pr = *q.begin();
        q.erase(q.begin());
        int cl = -pr.first, v = pr.second;

        for (auto u: g[v]) {
            int ncl = (a[u] < cl? cl: cl / 2);
            if (dist[u] < ncl) {
                dist[u] = ncl;
                q.emplace(-ncl, u);
            }
        }
    }
    
    cout << dist[n - 1] << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    fastio();
    int tt = 1;
    // cin >> tt;
    while (tt-- > 0)
        solve();
    return 0;
}
