#include <algorithm>
#include <cassert>
#include <cmath>
#include <iomanip>
#include <ios>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <string>
#include <unordered_map>
#include <utility>
#include <vector>
#include <numeric>
#include <random>
using namespace std;

#define int long long

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)(x).size()
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define pb push_back
using ll = long long;
using db = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vi = vector<int>;
using vll = vector<ll>;

void fastio() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
    cin.exceptions(ios::failbit);
}

mt19937 rng(11);

db rnd() { return 1.0L * rng() / rng.max(); }

inline void solve() noexcept {
    int n;
    cin >> n;

    vector<int> a(n), b(n);
    forn(i, n) cin >> a[i];
    forn(j, n) cin >> b[j];

    int aa = 0, bb = 0;
    int ans = 0;

    forn(i, n) {
        aa ^= a[i];
        bb ^= b[i];
    }

    vector<int> sw(n);
    vector<int> x(n);
    forn(i, n) x[i] = a[i] ^ b[i];

    db t = 1;
    forn(k, 10000000) {
        t *= 0.999;
        int p = rng() % n;

        int aa1 = aa ^ x[p], bb1 = bb ^ x[p];

        if (aa1 + bb1 > aa + bb || rng() < exp(((aa1 + bb1) - (aa + bb))) / t) {
            swap(a[p], b[p]);
            aa = aa1;
            bb = bb1;

            sw[p] ^= 1;
        }
    }

    vector<int> answ;
    forn(i, n) {
        if (sw[i]) answ.pb(i);
    }

    cout << aa + bb << ' ' << sz(answ) << '\n';
    for (auto en: answ) cout << en << ' '; 
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    fastio();
    int tt = 1;
    // cin >> tt;
    while (tt-- > 0)
        solve();
    return 0;
}
