#include <algorithm>
#include <cassert>
#include <cmath>
#include <iomanip>
#include <ios>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <string>
#include <unordered_map>
#include <utility>
#include <vector>
using namespace std;

#define int long long

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)(x).size()
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define pb push_back
using ll = long long;
using db = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vi = vector<int>;
using vll = vector<ll>;

void fastio() {
  cin.tie(nullptr);
  cout.tie(nullptr);
  ios::sync_with_stdio(false);
  cin.exceptions(ios::failbit);
}

inline void solve() noexcept {
  int a, b;
  cin >> a >> b;

  if (a == 0 || b == 0) {
    cout << "0\n";
    return;
  }

  int cnt = 0;

  vector<pii> ans;
  if (a < 0) {
    if (b < 0) {
      ans.pb({1, -(a + b - 1) / b});
      a -= ((a + b - 1) / b) * b;
      cnt++;
    } else {
      ans.pb({1, (-a + b - 1) / b});
      a += ((-a + b - 1) / b) * b;
      cnt++;
    }
  }

  if (b < 0) {
    ans.pb({2, (-b + a - 1) / a});
    b += ((-b + a - 1) / a) * a;
    cnt++;
  }

  while (a != 0 && b != 0) {
    cnt++;
    assert(cnt < 50);
    if (a > b) {
      ans.pb({1, -a / b});
      a %= b;
    } else {
      ans.pb({2, -b / a});

      b %= a;
    }
  }
  
  cout << sz(ans) << '\n';
  for (auto [t, k]: ans) {
    cout << t << ' ' << k << '\n';
  }
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  fastio();
  int tt = 1;
  // cin >> tt;
  while (tt-- > 0)
    solve();
  return 0;
}
