#include <algorithm>
#include <cassert>
#include <cmath>
#include <iomanip>
#include <ios>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <string>
#include <unordered_map>
#include <utility>
#include <vector>
using namespace std;

#define int long long

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)(x).size()
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define pb push_back
using ll = long long;
using db = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vi = vector<int>;
using vll = vector<ll>;

void fastio() {
  cin.tie(nullptr);
  cout.tie(nullptr);
  ios::sync_with_stdio(false);
  cin.exceptions(ios::failbit);
}

char sign(int a) {
  return (a > 0) - (a < 0);
}

inline void solve() noexcept {
  int a, b;
  cin >> a >> b;

  if (a == 0 || b == 0) {
    cout << "0\n";
    return;
  }

  map<pair<int, int>, int> dist;
  map<pair<int, int>, pair<int, int>> prev;
  map<pair<int, int>, pair<int, int>> op;

  pair<int, int> ansp;
  int ans = 1e9;

  queue<pii> q;
  q.push({a, b});
  dist[{a, b}] = 0;

  clock_t time = clock();
  while (!q.empty() && 1.0 * (clock() - time) / CLOCKS_PER_SEC < 0.7) {
    auto pr = q.front();
    int na = pr.first, nb = pr.second;
    q.pop();

    if ((na == 0 || nb == 0) && dist[{na, nb}] < ans) {
      ans = dist[{na, nb}];
      ansp = {na, nb};
    }

    if (na == 0 || nb == 0) continue;

    if (abs(na) > abs(nb)) {
      int mul = -1;
      if (sign(na) != sign(nb)) mul = 1;

      int d1 = abs(na) / abs(nb), d2 = (abs(na) + abs(nb) - 1) / abs(nb);

      int na1 = na + nb * d1 * mul, na2 = na + nb * d2 * mul;

      if (dist.count({na1, nb}) == 0) {
        dist[{na1, nb}] = dist[{na, nb}] + 1;
        prev[{na1, nb}] = {na, nb};
        op[{na1, nb}] = {1, d1 * mul};

        q.emplace(na1, nb);
      }

      if (dist.count({na2, nb}) == 0) {
        dist[{na2, nb}] = dist[{na, nb}] + 1;
        prev[{na2, nb}] = {na, nb};
        op[{na2, nb}] = {1, d2 * mul};

        q.emplace(na2, nb);
      }
    } else {
      int mul = -1;
      if (sign(na) != sign(nb)) mul = 1;

      int d1 = abs(nb) / abs(na), d2 = (abs(nb) + abs(na) - 1) / abs(na);

      int nb1 = nb + na * d1 * mul, nb2 = nb + na * d2 * mul;

      if (dist.count({na, nb1}) == 0) {
        dist[{na, nb1}] = dist[{na, nb}] + 1;
        prev[{na, nb1}] = {na, nb};
        op[{na, nb1}] = {2, d1 * mul};

        q.emplace(na, nb1);
      }

      if (dist.count({na, nb2}) == 0) {
        dist[{na, nb2}] = dist[{na, nb}] + 1;
        prev[{na, nb2}] = {na, nb};
        op[{na, nb2}] = {2, d2 * mul};

        q.emplace(na, nb2);
      }
    }
  }
  
  vector<pii> answ;

  while (ansp != pair{a, b}) {
    answ.push_back(op[ansp]);
    ansp = prev[ansp];
  }

  reverse(all(answ));
  cout << sz(answ) << '\n';

  for (auto [t, k]: answ) {
    cout << t << ' ' << k << '\n';
  }
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  fastio();
  int tt = 1;
  // cin >> tt;
  while (tt-- > 0)
    solve();
  return 0;
}
