﻿#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <bitset>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <cctype>
#include <cassert>
#include <climits>
#include <ctime>
#include <iostream>
#include <iomanip>
#include <functional>
#include <map>
#include <string>
#include <queue>
#include <stack>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <vector>
#include <array>
#include <random>
#include <chrono>

//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,fma")
//#pragma GCC optimization ("O3")
//#pragma GCC optimization ("unroll-loops")
using namespace std;
using namespace std::chrono;

#define all(x) x.begin(), x.end()
#define int long long

template <class T>
istream& operator >>(istream& in, vector<T>& arr) {
	for (T& cnt : arr) {
		in >> cnt;
	}
	return in;
}

const int N = 2e5 + 1;
const int INF = 2e9;
int x;
vector<int> a, dp;
vector<vector<int>> graph;

void dijkstra() {
	set<pair<int, int>> st;
	dp[1] = x;
	st.insert({x, 1});
	while (st.size()) {
		pair<int, int> p = *st.rbegin();
		int q = p.second;
		int d = p.first;
		//cout << q << '\n';
		st.erase(p);
		for (int i = 0; i < graph[q].size(); i++) {
			int cnt = d;
			//cout << graph[q][i] << ' ' << cnt << '\n';
			if (a[graph[q][i]] >= cnt) {
				cnt /= 2;
			}
			if (cnt > dp[graph[q][i]]) {
				st.erase({ dp[graph[q][i]], graph[q][i] });
				dp[graph[q][i]] = cnt;
				st.insert({ dp[graph[q][i]], graph[q][i] });
			}
		}
	}
}

void solve() {
	int n, m; cin >> n >> m;
	graph.resize(n + 1);
	dp.resize(n + 1);
	a.resize(n + 1);
	for (int i = 0; i < m; i++) {
		int x, y; cin >> x >> y;
		graph[x].push_back(y);
		graph[y].push_back(x);
	}
	cin >> x;
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
	}
	if (a[1] >= x) x /= 2;
	dijkstra();
	cout << dp[n] << '\n';
}


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	//freopen("game.in", "r", stdin);
	//freopen("game.out", "w", stdout);
	int _t = 1; //cin >> _t;
	while (_t--) {
		solve();
		//gen();
	}
}